function $(id) { return document.getElementById(id); }
function $$(tagName, context) { return (context || document).getElementsByTagName(tagName); }
function $D() { return (new Date).toGMTString()
  .replace(/( |:|,)/g, function($_, $1) {
    switch ($1) {
    case ' ': return '+';
    case ':': return '%3A';
    case ',': return '%2C';
    }
  });
}
var Xwitter = {
  GMT: $D(),
  DOC: document.implementation.createDocument('', '', null),
  XSL: new XSLTProcessor,
  HTT: /(https?:\/\/[-_.!~*\'()\w;\/?:\@&=+\$,%#]+)/,
  URL: $('url'),
  BOX: $('box'),
  FRM: $('status_update_form'),
  TXT: $('status'),
  BTN: $('update-submit'),
  HDN: $('in_reply_to_status_id'),

  initialize: function() {
    this.DOC.async = false;
    this.DOC.load('xwitter.xsl');
    this.XSL.importStylesheet(this.DOC);
    this.BTN.addEventListener('click', function() {
      Xwitter.update();
    }, false);
    window.addEventListener('keydown', function(event) {
      switch (event.keyCode) {
      case KeyEvent.DOM_VK_ESCAPE:
        Xwitter.escape();
        return;
      }
      if (event.altKey)
        switch (event.keyCode) {
        case KeyEvent.DOM_VK_U:
          Xwitter.focus();
          return;
        }
      if (event.ctrlKey)
        switch (event.keyCode) {
        case KeyEvent.DOM_VK_R:
          Xwitter.refresh();
          return;
        case KeyEvent.DOM_VK_W:
          window.close();
          return;
        }
    }, false);
  },

  refresh: function() {
    var xhr = new XMLHttpRequest;
    xhr.onreadystatechange = function() {
      if (xhr.readyState !== 4 || xhr.status !== 200) return;
      var old = Xwitter.BOX.replaceChild(Xwitter.XSL.transformToFragment(xhr.responseXML, document), Xwitter.BOX.firstChild);
      for (var c, i = 0, e = $$('input'); c = e[i++];)
        c.addEventListener('click', Xwitter[c.alt ? 'reply' : 'fav'], false);
      for (var c, i = 0, e = $$('p'); c = e[i++];) {
        c.addEventListener('dblclick', Xwitter.findURL, false);
        if (Xwitter.EXP.test(c.textContent)) c.className += ' highlight';
      }
      Xwitter.BOX.firstChild.style.display = 'block';
      Xwitter.free(old);
      old = null;
      Xwitter.notify();
    };
    xhr.open('get', protocol + '://twitter.com/statuses/friends_timeline.xml?since=' + Xwitter.GMT);
    xhr.send(null);
    Xwitter.wait();
    Xwitter.GMT = $D();
    return arguments.callee;
  },

  free: function(old) {
    for (var c, i = 0, e = $$('input', old); c = e[i++];)
      c.removeEventListener('click', Xwitter[c.alt ? 'reply' : 'fav'], false);
    for (var c, i = 0, e = $$('p', old); c = e[i++];)
      c.removeEventListener('dblclick', Xwitter.findURL, false);
  },

  fav: function() {
    var elm = this, fav = elm.className === 'true';
    var xhr = new XMLHttpRequest;
    xhr.onreadystatechange = function() {
      if (xhr.readyState !== 4 || xhr.status !== 200) return;
      elm.className = !fav;
      Xwitter.notify();
    };
    xhr.open('post', [
      protocol,
      '://twitter.com/favourings/',
      fav ? 'destroy' : 'create',
      '/',
      elm.title,
      '.xml'
      ].join(''));
    xhr.send(null);
    Xwitter.wait();
  },

  reply: function() {
    Xwitter.HDN.value = this.title;
    Xwitter.TXT.value = '@' + this.alt + ' ';
    Xwitter.focus();
  },

  update: function() {
    var xhr = new XMLHttpRequest;
    xhr.onreadystatechange = function() {
      if (xhr.readyState !== 4 || xhr.status !== 200) return;
      Xwitter.refresh();
      Xwitter.escape();
      Xwitter.notify();
    };
    xhr.open('post', [
      protocol,
      '://twitter.com/statuses/update.xml?',
      this.TXT.id,
      '=',
      encodeURIComponent(this.TXT.value),
      '&',
      this.HDN.id,
      '=',
      this.HDN.value,
      '&source=xwitter'
      ].join(''));
    xhr.send(null);
    Xwitter.wait();
  },

  focus: function() {
    this.FRM.style.display = 'block';
    this.TXT.focus();
  },

  escape: function() {
    this.FRM.style.display = 'none';
    this.TXT.value = this.HDN.value = '';
  },

  findURL: function() {
    if (!Xwitter.HTT.exec(this.textContent)) return;
    var url = RegExp.$1;
    var xhr = new XMLHttpRequest;
    xhr.onreadystatechange = function() {
      if (xhr.readyState !== 4) return;
      Xwitter.URL.value = xhr.status !== 200 ? url : eval('(' + xhr.responseText + ')').url || url;
      Xwitter.URL.select();
      Xwitter.notify();
    };
    xhr.open('get', 'http://ss-o.net/api/reurl.json?url=' + encodeURIComponent(url));
    xhr.send(null);
    Xwitter.wait();
  },

  wait: function() {
    Xwitter.BOX.style.cursor = 'wait';
  },

  notify: function() {
    Xwitter.BOX.style.cursor = 'auto';
  }
};
