<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns="http://www.w3.org/1999/xhtml"
	version="1.0">
	<xsl:output method="xml"
		encoding="utf-8"
		omit-xml-declaration="no"
		doctype-public="-//W3C//DTD XHTML 1.1//EN"
		doctype-system="http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd"
		indent="no"
		media-type="application/xhtml+xml" />

	<xsl:template match="statuses">
		<html xml:lang="ja">
			<head profile="http://www.w3.org/2003/g/data-view">
				<title>Xwitter</title>
				<link rel="transformation" href="http://www.kanzaki.com/parts/xh2rdf.xsl" />
			</head>
			<body>
				<xsl:apply-templates select="status" />
			</body>
		</html>
	</xsl:template>

	<xsl:template match="status">
		<div class="section" id="{generate-id()}">
			<xsl:apply-templates select="user" />
		</div>
	</xsl:template>

	<xsl:template match="user">
		<img src="{profile_image_url}" alt="" />
		<input type="hidden" title="{../id}" class="{../favorited}" />
		<input type="hidden" title="{../id}" class="reply" alt="{screen_name}" />
		<em><xsl:value-of select="screen_name" /></em>
		<p>
			<xsl:if test="protected = 'true'">
				<xsl:attribute name="class">protect</xsl:attribute>
			</xsl:if>
			<xsl:value-of select="../text" />
		</p>
	</xsl:template>

</xsl:stylesheet>
